Overview | Modules | Class Hierarchy | Classes | Members

# tlp::GlQuad Class Reference

`#include <GlQuad.h>`

Inherits tlp::GlSimpleEntity.

Inheritance diagram for tlp::GlQuad:

[legend]
Collaboration diagram for tlp::GlQuad:

[legend]
List of all members.

## Detailed Description

General class to render quads as augmented displays.

This class is a generic class to render quads as augmented displays. It doens't uses the basic parameters of the GlAugmentedDisplay(position and color) but it's own set of positions and colors.

## Public Member Functions

- GlQuad ()
- GlQuad (Coord positions[N_QUAD_POINTS], const Color &color)
- GlQuad (Coord positions[N_QUAD_POINTS], Color colors[N_QUAD_POINTS])
- virtual ~GlQuad ()
- virtual void draw (float lod, Camera *camera)
- void setPosition (int idPosition, const Coord &position)
- void setColor (int idColor, const Color &color)
- void setColor (const Color &color)
- Coord * getPosition (int idPosition) const
- Color * getColor (int idColor) const
- void setTextureName (const std::string &name)
- std::string getTextureName () const
- virtual void translate (const Coord &mouvement)
- virtual void getXML (xmlNodePtr rootNode)
- virtual void setWithXML (xmlNodePtr rootNode)

## Protected Member Functions

- void setPosition (const Coord &position)

## Protected Attributes

- Coord * positions [N_QUAD_POINTS]
- Color * colors [N_QUAD_POINTS]
- std::string textureName

## Constructor & Destructor Documentation

tlp::GlQuad::GlQuad | ( |  | ) |

| Constructor

tlp::GlQuad::GlQuad | ( | Coord | positions[N_QUAD_POINTS],
|  | const Color & | color
| ) |

Constructor

Parameters:

  | positions | Array indicating the position of the points. The first point is the top-left one. The next points are winding in clockwise order.
  | color | A single color indicating the color for every point of the Quad.

tlp::GlQuad::GlQuad | ( | Coord | positions[N_QUAD_POINTS],
|  | Color | colors[N_QUAD_POINTS]
| ) |

Constructor

Parameters:

  | positions | Array indicating the position of the points. The first point is the top-left one. The next points are winding in clockwise order.
  | colors | Array indicating the color of the points. The order is the same as for the positions.

virtual tlp::GlQuad::~GlQuad | ( |  | ) | `[virtual]`

| Destructor

## Member Function Documentation

virtual void tlp::GlQuad::draw | ( | float | lod,
|  | Camera * | camera
| ) | `[virtual]`

| Virtual function used to draw the quad. Implements tlp::GlSimpleEntity.

Color* tlp::GlQuad::getColor | ( | int | idColor | ) | const

Accessor in reading to the color.

Parameters:

  | idColor | Indicates which point we want to get the color.

Coord* tlp::GlQuad::getPosition | ( | int | idPosition | ) | const

Accessor in reading to the position.

Parameters:

  | idPosition | Indicates which point we want to get the position.

std::string tlp::GlQuad::getTextureName | ( |  | ) | const

| Accessor in reading to the texture.

virtual void tlp::GlQuad::getXML | ( | xmlNodePtr | rootNode | ) | `[virtual]`

| Function to export data in XML Implements tlp::GlSimpleEntity.

void tlp::GlQuad::setColor | ( | const Color & | color | ) |

Accessor in writing to the basic color of GlAugmentedDisplay

Attention:
  As you can see, this function is forbidden to the user to avoid him setting an unused parameter.

void tlp::GlQuad::setColor | ( | int | idColor,
|  | const Color & | color
| ) |

Accessor in writing to the color.

Parameters:

  | idColor | Indicates which point we want to colorize.

void tlp::GlQuad::setPosition | ( | int | idPosition,
|  | const Coord & | position
| ) |

Accessor in writing to the position.

Parameters:

  | idPosition | Indicates which point we want to move.

void tlp::GlQuad::setPosition | ( | const Coord & | position | ) | `[protected]`

Accessor in writing to the basic position of GlAugmentedDisplay

Attention:
  As you can see, this function is forbidden to the user to avoid him setting an unused parameter.

void tlp::GlQuad::setTextureName | ( | const std::string & | name | ) |

| Accessor in reading to the texture.

virtual void tlp::GlQuad::setWithXML | ( | xmlNodePtr | rootNode | ) | `[virtual]`

| Function to set data with XML Implements tlp::GlSimpleEntity.

virtual void tlp::GlQuad::translate | ( | const Coord & | mouvement | ) | `[virtual]`

| Translate entity Reimplemented from tlp::GlSimpleEntity.

## Member Data Documentation

Color* tlp::GlQuad::colors[N_QUAD_POINTS]`[protected]`

| The colors of the points of the Quad

Coord* tlp::GlQuad::positions[N_QUAD_POINTS]`[protected]`

| The position of the points of the Quad

std::string tlp::GlQuad::textureName `[protected]`

Tulip Software by LaBRI Visualization Team 2001 - 2010